import { Injectable } from '@angular/core';
import { Router } from '@angular/router';

import { MatDialog } from '@angular/material/dialog';
import { IObjectListUIService } from '@objects-view/interfaces/object-list-ui-service';
import { ConfigService } from '@shared/config/config.service';
import { IBaseFleioObjectModel } from '@fleio-api/base-model/base-fleio-object.model';
import { IPermissionsModel } from '@fleio-api/base-model/IPermissionsModel';
import { IObjectUIService } from '@objects-view/interfaces/object-ui-service';
import { FleioObjectsList } from '@fleio-api/fleio-objects-list';
import { ITableData } from '@objects-view/interfaces/table-data/table-data';
import { ColumnType } from '@objects-view/interfaces/table-data/column-definition';
import { ITableRow } from '@objects-view/interfaces/table-data/table-row';
import { IAction } from '@objects-view/interfaces/actions/action';
import { RouterLinkAction } from '@objects-view/actions/router-link-action';
import { PredefinedReplyUiService } from './predefined-reply-ui.service';
import { DateFormatterPipe } from '@shared/ui/common/pipes/date-formatter.pipe';
import { PredefinedReplyCategoryApiService } from '@fleio-api/plugins/tickets/predefined-reply-category-api.service';
import { IPredefinedReplyCategoryModel } from '@fleio-api/plugins/tickets/model/predefined-reply-category.model';

@Injectable({
  providedIn: 'root',
})
export class PredefinedRepliesListUiService implements IObjectListUIService {
  public noItemsMessage = $localize`No categories`;

  private readonly datePipe: DateFormatterPipe;

  constructor(
    private router: Router, private config: ConfigService,
    private predefinedReplyCategoryApiService: PredefinedReplyCategoryApiService,
    private matDialog: MatDialog,
    ) {
    this.datePipe = new DateFormatterPipe(this.config);
  }

  getObjectUIService(
    object: IBaseFleioObjectModel, permissions: IPermissionsModel, state: string
  ): IObjectUIService {
      return new PredefinedReplyUiService(
        object as IPredefinedReplyCategoryModel, permissions, state, this.router, this.config,
        this.predefinedReplyCategoryApiService,
        this.matDialog,
      );
  }

  getTableData(objectList: FleioObjectsList<IPredefinedReplyCategoryModel>): ITableData {
    const tableData: ITableData = {
      header: {
        columns: [
          {
            type: ColumnType.Value, displayName: $localize`Name`, enableSort: true, fieldName: 'name', flex: '300px',
            flexXs: '150px'
          },
          {
            type: ColumnType.Value, displayName: $localize`Predefined replies`, enableSort: false,
            fieldName: 'replies_count', flex: '180px'
          },
          {
            type: ColumnType.Value, displayName: $localize`Created at`, enableSort: true, fieldName: 'created_at',
            flex: '180px', hide: {xs: true, sm: true}
          },
          { type: ColumnType.Actions, displayName: $localize`Actions`, enableSort: false, fieldName: '(actions)' },
        ],
        columnNames: ['name', 'replies_count', 'created_at', '(actions)'],
      },
      rows: [],
    };

    for (const object of objectList.objects) {
      const rowUIService = this.getObjectUIService(object, objectList.permissions, 'table-view');
      const row: ITableRow = {
        cells: {
          name: { text: object.name },
          replies_count: { text: object.replies_count.toString() },
          created_at: {
            text: this.datePipe.transform(object.created_at),
            title: this.datePipe.getTitleAttributeValue(object.created_at)
          },
        },
        icon: rowUIService.getIcon(),
        status: rowUIService.getStatus(),
        actions: rowUIService.getActions(),
        url: rowUIService.getDetailsLink(),
      };

      tableData.rows.push(row);
    }

    return tableData;
  }

  getActions(objectList: FleioObjectsList<IBaseFleioObjectModel>): IAction[] {
    return [
      new RouterLinkAction({
        name: $localize`Add category`,
        tooltip: $localize`Add category`,
        icon: { name: 'add' },
        router: this.router,
        routerUrl: this.config.getPanelUrl('tickets/predefined-replies/create-category'),
        noPermissions: !objectList.permissions['predefined_reply_categories.create'],
      })
    ];
  }

  getRefreshInterval(): number {
    if (this.config && this.config.current && this.config.current.settings &&
      this.config.current.settings.refreshIntervals) {
      return this.config.current.settings.refreshIntervals.defaultInterval;
    }
    return 10000;
  }
}
